#!/bin/sh

#caso =1 scarica kernel dalla rete , =2 decomprimi kernel file precedentemente scaricato

caso=$1

link_kernel_path="http://www.kernel.org/pub/linux/kernel/"

if test $caso -eq 1
then
	echo "Test della rete in corso.... ( potrebbe volerci anche qualche minuto )"
	ping -c1 www.kernel.org
	net_test=$?
else
	net_test="2"
fi

if test $net_test -ne 0
then
	if test $caso -eq 1
	then

	echo "Non e' disponibile una connessione internet."
	fi

	echo "Indicare il file sorgente scaricato precedentemente da decomprimere es. /home/user/linux-x.x.x.tar.gz"
	read nome_file_kernel

	echo $nome_file_kernel > $file_temp1

	egrep -o $mask_kernel"\.tar\.gz" $file_temp1 > $file_temp2

	n_file=$(wc -c < $file_temp2)

	if test $n_file -eq 0
	then
		echo "Nome file non corretto, accertarsi che sia un file come nell'esempio /home/user/linux-x.x.x.tar.gz."
		exit 1;ls

	fi

	ls $nome_file_kernel > $file_temp1

	if test $? -ne 0
	then
		echo "File non esistente "$nome_file_kernel" accertarsi di un file esistente."
		exit

	fi
	echo "Dove si vuole decomprimere il file compresso ( $nome_file_kernel ) del nuovo kernel [/usr/src/ ] ?"
	read dir_file

	echo $dir_file > $file_temp1
	n_char=$(wc -c < $file_temp1)

	if test $n_char -ne 1
	then

	#aggiungo lo slash se necessario
	dir_file=$(awk -f $file_addslash < $file_temp1)

	else

	#default
	dir_file="/usr/src/"

	fi

	cd $dir_file
	if test $? -ne 0
	then

	echo "Potrebbe essere stata inserita una directory sbagliata, il file verr scaricato nella directory corrente."


	exit
	fi


else
	#pulizia
	rm index*

	#accedo alla directory di tutti i kernel
	wget $link_kernel_path

	egrep -o 'v[0-9]{1,}\.[0-9]{1,}' ./index.html > $file_temp1

	#ricavo ultimo kernel stabile
	sort -r $file_temp1 | head -1 > $file_temp2
	kernel=$(cat $file_temp2)

	#ricavo numero senza v
	versione=$(egrep -o '[0-9]{1,}\.[0-9]{1,}' $file_temp2)

	rm -f $file_temp2 $file_temp3 ./index*
	wget $link_kernel_path$kernel\/

# 	#ricavo l'ultimo kernel disponibile da scaricare
# 	egrep -o $mask_kernel"\.tar\.gz" ./index.html > $file_temp1
# 	sort -r $file_temp1 | head -1 > $file_temp2

	#ricavo l'ultimo kernel disponibile da scaricare in base alla data dei files

	grep "alt=\"\[ " ./index.html > ./index_ok

	awk '{ printf("%s \n",$8); } ' < ./index_ok > $file_temp1

	n_righe=$(wc -l < $file_temp1)
	z=1;
	while test $z -lt $(expr $n_righe + 1); do

	riga=$(head -$z $file_temp1 | tail -1)
	date -d$riga -I >> $file_temp2

	z=$(expr $z + 1)
	done

	awk '{ printf("%s \n",$7); }' < ./index_ok > $file_temp1

	z=1;
	while test $z -lt $(expr $n_righe + 1); do

	r_data=$(head -$z $file_temp2 | tail -1)
	r_file=$(head -$z $file_temp1 | tail -1)

	echo $r_data"   "$r_file >> $file_temp3

	z=$(expr $z + 1)
	done

	sort -r $file_temp3 > $file_temp1

	egrep -o $mask_kernel"\.tar\.gz" $file_temp1 | head -1 > $file_temp2


	#pulizia
	rm ./index*

	nome_file_kernel=$(cat $file_temp2)

	echo "Ultima versione disponibile: "$(egrep -o $mask_version $file_temp2)" la si vuole scaricare? [1]"
	echo [1] Si
	echo [2] No

	read -n1 risp
	echo

	if test $risp -eq 0
	then
	    risp=1
	else

	if test $risp -ne 1
	then
		exit 2;
	fi
	fi

	echo "Dove si vuole scaricare e poi decomprimere il file compresso ( "$nome_file_kernel" ) del nuovo kernel [/usr/src/ ] ?"

	read dir_file

	echo $dir_file > $file_temp1
	n_char=$(wc -c < $file_temp1)

	if test $n_char -ne 1
	then

	#aggiungo lo slash se necessario
	dir_file=$(awk -f $file_addslash < $file_temp1)

	else

	#default
	dir_file="/usr/src/"

	fi

	cd $dir_file
	if test $? -ne 0
	then

	echo "Potrebbe essere stata inserita una directory sbagliata, il file verr scaricato nella directory corrente."


	exit
	fi

	echo "Scaricamento in corso..."

	#scarico il file
	wget $link_kernel_path$kernel\/$nome_file_kernel 2> /dev/stdout

fi

#decomprimo il file
tar -xvzf $nome_file_kernel

#se e' necessario in file_temp1 ho la directory del kernel sorgente scaricato

echo $nome_file_kernel > $file_temp1
egrep -o $mask_kernel"\.tar\.gz" $file_temp1 > $file_temp2

dir_kernel=$dir_file$(awk '{lunghezza=length;
 		   printf("%s",substr($1,1,lunghezza-7));
		   }' < $file_temp2 )

echo $dir_kernel > $file_temp1
dir_kernel=$(awk -f $file_addslash < $file_temp1)

#memorizzo la directory dell'ultimo kernel scaricato
echo $dir_kernel > $file_temp1

#memorizzo il file compresso dell'ultimo kernel decompresso
echo $dir_file$nome_file_kernel > $file_temp2

