#!/bin/sh

# Passare come parametro la directory del kernel da compilare e la modalit e la directory di boot e  importa, se 1  avvenuta una importazione e non si puo' scegliere un'altro file di configurazione se si sceglie oldconfig, se 2 non  avvenuta importazione e si pu scegliere

if test $# != 4
then
    echo "Non abbastanza parametri, devono esserci: versione , gestore_input";
    echo "Paramentri immessi: 1:"$1" 2:"$2" 3:"$3" 4:"$4" "
    exit;
fi

dir_source=$1
mode=$2
dir_boot=$3
importa=$4

echo $dir_source > $file_temp3
versione=$(egrep -o $mask_version $file_temp3)

echo "Avvio compilazione e installazione kernel "$versione

cd $dir_source

if test $mode = "oldconfig"
then

if test $importa -ne 1
then

cd $dir_source
cd ..
ls -l > $file_temp2
egrep -o $mask_kernel"$" $file_temp2 > $file_temp1

sort -r $file_temp1 | uniq > $file_temp3

n_kernel=$(wc -l < $file_temp3)

if test $n_kernel -ne 0
then

echo
echo "Seleziona il kernel dal quale ricavare la configurazione"
i=1;
while test $i -lt $(expr $n_kernel + 1); do

echo "[$i] "$(head -$i $file_temp3 | tail -1)
i=$(expr $i + 1)

done

if test -f /proc/config.gz
then
	echo "[$i] Kernel attualmente caricato"
fi

read -n1 kernel_sorg

if test $kernel_sorg -eq $i
then
	cd $dir_source
	zcat /proc/config.gz > .config ;

else
	dir_kernel_old=$PWD"/"$(head -$kernel_sorg $file_temp3 | tail -1)
	cp -f $dir_kernel_old"/.config" $dir_source
fi


fi

fi
fi

cd $dir_source
make $mode && make dep && make bzImage && make modules && make modules_install && make install


if test $? -eq 0
then
cp -f /System.map-$versione $dir_boot
cp -f /vmlinuz-$versione $dir_boot
cp -f /config-$versione $dir_boot

cd /

#creazione classico link alla directory del kernel sorgente

sh $file_check_distro

rm -f /usr/src/linux
ln -s $dir_source /usr/src/linux

# verifica se sistema basato su libc6
ls /lib/libc.so.6 >> /dev/null
err_libc6=$?    #0 esiste #1 no

#se non e' una distribuzione debian e non e' basato su libc6
if test $distro -ne "Debian" && err_libc6 -ne 0
then

rm -f /usr/include/asm
ln -s /usr/src/linux/include/asm /usr/include/asm

fi

if test $distro -ne "Debian"
then

ln -s /usr/src/linux/include/linux /usr/include/linux

fi

echo "Compilazione avvenuta con successo.Il bootloader e' stato aggiornato e il nuovo kernel e' stato chiamato \"Linux\" , editare il file di configurazione opportuno per cambiare nome e riavviare la macchina per rendere effettive le modifiche."

else

echo "Problemi durante la compilazione, verificare il file Errori.log per risolvere il problema."
fi

cd $dir



