#!/bin/sh

dir_corrent=$(pwd)
file_temp1=$(echo $dir_corrent"/temp1")
file_temp2=$(echo $dir_corrent"/temp2")
file_temp3=$(echo $dir_corrent"/temp3")
file_addslash=$(echo $dir_corrent"/add_slash.awk")
file_run_kernel=$(echo $dir_corrent"/run_kernel.sh")
file_run_install_kernel=$(echo $dir_corrent"/run_install_kernel.sh")
file_download_kernel=$(echo $dir_corrent"/download_kernel.sh")
file_check_distro=$(echo $dir_corrent"/check_distro.sh")
file_import=$(echo $dir_corrent"/import.sh")


file_errori=$(echo $dir_corrent"/Errori.log")

distro_riconosciute="Debian|Red Hat|Mandrake|SuSE|Slackware|Knoppix"
mask_version="[0-9]{1,}\.[0-9]{1,}\.[0-9]{1,}(\.[0-9]){0,}"
mask_kernel="linux-"$mask_version

distro=""

#file_update_bootloader=$(echo $dir_corrent"/update_bootloader.sh")

export file_temp1
export file_temp2
export file_temp3
export file_addslash
export file_run_kernel
export file_run_install_kernel
export file_download_kernel
export file_check_distro

export distro_riconosciute
export distro

export file_import
export mask_kernel
export mask_version
export dir_corrent

#export file_update_bootloader

#controllo utente
if test $USER != "root"
then
echo "Questo programma va eseguito con privilegi da root"
exit
fi

#controllo unico eseguibile
ps -aux | egrep -o '*_kernel4me\.sh*' > $file_temp1
if test $(wc -l < $file_temp1) -ne 1
then
echo "Programma gia' avviato, non e' possibile avviarne piu' di uno contemporaneamente"

exit
fi

risp=0
esci=7
while test $risp -ne $esci; do

echo "Premi [2]:"
echo "[1] Scarica sorgenti ultimo kernel e compilalo in seguito"
echo "[2] Scarica sorgenti ultimo kernel e compilalo subito"
echo "[3] Decomprimi kernel e compilalo in seguito"
echo "[4] Decomprimi kernel e compilalo subito"
echo "[5] Lancia compilazione di un kernel precedentemente scaricato e decompresso"
echo "[6] Visualizza eventuali errori ( premere q per uscire e frecce o spazio per leggere il testo )"
echo "[7] Esci"
echo "[8] Intenzioni future e info-line"
read -n1 risp

#vai a capo
echo

case $risp in

1) sh $file_download_kernel 1;;
2) sh $file_download_kernel 1
   if test $? -eq 0
   then
   	#cat $file_temp1
   	sh $file_run_kernel $(cat $file_temp1)
   fi
;;
3) sh $file_download_kernel 2;;
4) sh $file_download_kernel 2
   if test $? -eq 0
   then
	cat $file_temp1
	sh $file_run_kernel $(cat $file_temp1)
   fi
;;
5)

risp=1

while test $risp -ne 4;
do

echo "Indicare la directory dove normalmente si tengono i sorgenti dei kernel [/usr/src/ ] ?"
read dir_kernel
echo $dir_kernel > $file_temp1
n_char=$(wc -c < $file_temp1)

if test $n_char -ne 1
then
#aggiungo lo slash se necessario
dir_kernel=$(awk -f $file_addslash < $file_temp1)
else
#default
dir_kernel="/usr/src/"
fi

cd $dir_kernel
if test $? -ne 0
then

echo "Potrebbe essere stata inserita una directory sbagliata, provare a reinserirla"
	risp=1
else
	risp=4

fi

done


ls -l $dir_kernel > $file_temp2
egrep -o $mask_kernel"$" $file_temp2 > $file_temp1
sort -r $file_temp1 | uniq > $file_temp3

n_kernel=$(wc -l < $file_temp3)

if test $n_kernel -ne 0
then

echo
echo "Seleziona il kernel da compilare"
i=1;
while test $i -lt $(expr $n_kernel + 1); do

echo "[$i] "$(head -$i $file_temp3 | tail -1)
i=$(expr $i + 1)

done


read -n1 kernel
kernel=$(head -$kernel $file_temp3 | tail -1)
dir_kernel=$dir_kernel$kernel"/"

sh $file_run_kernel $dir_kernel


#echo $dir_kernel
risp=4


else
echo "In questa directory non e' stato trovato nessun kernel sorgente, il nome della cartella deve essere nella forma 'linux-x.x.x' "

fi
;;
"")
   sh $file_download_kernel 1
   if test $? -eq 0
   then
   	#cat $file_temp1
   	sh $file_run_kernel $(cat $file_temp1)
   fi
   risp=2
;;

6) echo
   cat -r $file_errori | less

   echo;;
7) ;;
8) echo "E' intenzione dell'autore espandere questo programma alle seguenti funzionalita':"
   echo "[] Aggiornare il proprio kernel attraverso lo scaricamento delle ultime patch"
   echo "[] Aggiornare il proprio bootloader con piu' semplicita' attraverso domande guidate"
   echo "[] Rendere piu' intelligente, flessibile e resistibile agli errori il programma gia' fatto"
   echo "[] Possibilita' di multilingue e maggiore personalizzazione"
   echo "Per suggerimenti, insulti, bug o aiuto per l'uso contattare: boymix81@libero.it con oggetto \"Kernel For Me Help\" ";;

*) echo "Risposta interpretabile";;

esac

done

#pulizia
cd $dir_corrent
rm ./index*
rm ./temp*
